<template>
    <lightning-card  variant="Narrow"  title={accountName} icon-name="standard:account">
    </lightning-card>

    <br/><br/>

    <lightning-card title="Active Users" icon-name="standard:team_member">
      <template if:true={activeRamUsers}>
        <lightning-datatable
            key-field="id"
            data={activeRamUsers}
            columns={activeUserColumns}
            onrowaction={handleRowAction}
            show-row-number-column
            row-number-offset={rowOffset}
            hide-checkbox-column></lightning-datatable>
      </template>

    </lightning-card>

    <br/><br/>
    <lightning-card title="Inactive Users" icon-name="standard:team_member">
      <lightning-button label="New User" variant="neutral" slot="actions" icon-name="action:new_contact" onclick={openContactModal}></lightning-button>
      <template if:true={inactiveRamUsers}>
        <lightning-datatable
            key-field="id"
            data={inactiveRamUsers}
            columns={inactiveUserColumns}
            onrowaction={handleRowAction}
            show-row-number-column
            row-number-offset={rowOffset}
            hide-checkbox-column></lightning-datatable>
      </template>      
    </lightning-card> 
    
    <!--New Contact Create Modal-->
    <template if:true={showContactModal}>
      <section role="dialog"
              tabindex="-1"
              aria-labelledby="modal-heading-01"
              aria-modal="true"
              aria-describedby="modal-content-id-1"
              class="slds-modal slds-fade-in-open slds-modal-medium">
        <div class="slds-modal__container">
          <header class="slds-modal__header">
            <button class="slds-button slds-button_icon slds-modal__close slds-button_icon-inverse" title="Close" onclick={closeContactModal}>
              <lightning-icon icon-name="utility:close" size="medium">
              </lightning-icon>
              <span class="slds-assistive-text">Close</span>
            </button>
            <h2 id="modal-heading-01" class="slds-text-heading_medium slds-hyphenate">New Contact</h2>
          </header>

          <div class="slds-modal__content slds-p-around_medium" id="modal-content-id-1">
            <lightning-record-edit-form
                object-api-name="Contact"
                onload={overrideOwner}
                onsubmit={handleContactCreate}
                density="comfy">
              
              <lightning-messages></lightning-messages>
              <div class="slds-form__row">
                <div class="slds-form__item">
                  <lightning-input-field field-name="FirstName" required></lightning-input-field>
                </div>
                <div class="slds-form__item">
                  <lightning-input-field field-name="LastName" required></lightning-input-field>
                </div> 
              </div>
              <div class="slds-form__row">
                <div class="slds-form__item">
                  <lightning-input-field field-name="Email" required></lightning-input-field>
                </div>
                <div class="slds-form__item">
                  <lightning-input-field field-name="MobilePhone"></lightning-input-field>
                </div>
              </div>
              <div class="slds-form__row">
                <div class="slds-form__item">
                  <lightning-input-field field-name="Phone"></lightning-input-field>
                </div> 
                <div class="slds-form__item">
                  <lightning-input-field field-name="HomePhone"></lightning-input-field>
                </div>
              </div>   
              <div class="slds-form__row">
                <div class="slds-form__item">
                  <lightning-input-field field-name="OtherPhone"></lightning-input-field>
                </div> 
                <div class="slds-form__item">
                  <lightning-input-field field-name="Title"></lightning-input-field>
                </div> 
              </div>                         
              <div class="slds-form__row">
                <div class="slds-form__item">
                  <lightning-input-field field-name="MailingAddress"></lightning-input-field>
                </div>
              </div> 
              <div style="display: none;">
                <div class="slds-form__row">
                  <div class="slds-form__item">
                    <lightning-input-field field-name="AccountId" value={accountId} readonly></lightning-input-field>
                  </div>                
                </div>
                <lightning-input-field field-name="OwnerId" value={accountOwner} readonly></lightning-input-field>
              </div>
              <footer class="slds-modal__footer">
                <lightning-button label="Cancel" variant="neutral" onclick={closeContactModal}></lightning-button>&nbsp;&nbsp;&nbsp;&nbsp;
                <lightning-button label={saveButtonLabel} disabled={isSaveBtnDisabled} variant="brand" type="submit"></lightning-button>
            </footer>               
            </lightning-record-edit-form>
          </div>             
        </div>
      </section>
      <div class="slds-backdrop slds-backdrop_open"></div>      
    </template>

    <!--User activation role selection modal-->
    <template if:true={showUserSelectionModal}>
      <template if:false={selectedRow.hasUserAccount}>
        <section role="dialog"
                tabindex="-1"
                aria-labelledby="modal-heading-01"
                aria-modal="true"
                aria-describedby="modal-content-id-1"
                class="slds-modal slds-fade-in-open slds-modal-medium">
              
          <div class="slds-modal__container">
            <header class="slds-modal__header">
              <button class="slds-button slds-button_icon slds-modal__close slds-button_icon-inverse" title="Close" onclick={closeUserSelectionModal}>
                <lightning-icon icon-name="utility:close" size="medium">
                </lightning-icon>
                <span class="slds-assistive-text">Close</span>
              </button>
              <h2 class="slds-text-heading_medium slds-hyphenate">Select a role to active</h2>
            </header>

            <div class="slds-modal__content slds-p-around_medium">
              <lightning-button-group>
                <lightning-button label="Dispatcher" disabled={isSaveBtnDisabled} variant="brand-outline" class="slds-m-left_x-small" onclick={createDispatcherUser}></lightning-button>
                <lightning-button label="Technician" disabled={isSaveBtnDisabled} variant="brand-outline" class="slds-m-left_x-small" onclick={createTechnicianUser}></lightning-button>
                <lightning-button label="Cancel" variant="brand-outline" class="slds-m-left_x-small" onclick={closeUserSelectionModal}></lightning-button>
            </lightning-button-group>
            </div>
          </div>
        </section>
        <div class="slds-backdrop slds-backdrop_open"></div>
      </template>

      <template if:true={selectedRow.hasUserAccount}>
        <section role="dialog"
                tabindex="-1"
                aria-labelledby="modal-heading-01"
                aria-modal="true"
                aria-describedby="modal-content-id-1"
                class="slds-modal slds-fade-in-open slds-modal-medium">
              
          <div class="slds-modal__container">
            <header class="slds-modal__header">
              <button class="slds-button slds-button_icon slds-modal__close slds-button_icon-inverse" title="Close" onclick={closeUserSelectionModal}>
                <lightning-icon icon-name="utility:close" size="medium">
                </lightning-icon>
                <span class="slds-assistive-text">Close</span>
              </button>
              <h2 class="slds-text-heading_medium slds-hyphenate">User {selectedRow.name} alreay exists</h2>
            </header>

            <div class="slds-modal__content slds-p-around_medium">
              <lightning-button-group>
                <lightning-button label="Activate" disabled={isSaveBtnDisabled} variant="brand-outline" class="slds-m-left_x-small" onclick={activateUser}></lightning-button>
                <lightning-button label="Activate & Reset Password" disabled={isSaveBtnDisabled} variant="brand-outline" class="slds-m-left_x-small" onclick={activateAndResetPassword}></lightning-button>
                <lightning-button label="Cancel" variant="brand-outline" class="slds-m-left_x-small" onclick={closeUserSelectionModal}></lightning-button>
            </lightning-button-group>
            </div>
          </div>
        </section>    
        <div class="slds-backdrop slds-backdrop_open"></div>    
      </template>
      
    </template>

    <!--User decativation modal-->
    <template if:true={showDeactivateUserModal}>
      <section role="dialog"
              tabindex="-1"
              aria-labelledby="modal-heading-01"
              aria-modal="true"
              aria-describedby="modal-content-id-1"
              class="slds-modal slds-fade-in-open slds-modal-medium">
            
        <div class="slds-modal__container">
          <header class="slds-modal__header">
            <button class="slds-button slds-button_icon slds-modal__close slds-button_icon-inverse" title="Close" onclick={closeDeactivateUserModal}>
              <lightning-icon icon-name="utility:close" size="medium">
              </lightning-icon>
              <span class="slds-assistive-text">Close</span>
            </button>
            <h2 class="slds-text-heading_medium slds-hyphenate">Are you sure you want to deactivate {selectedRow.name}</h2>
          </header>

          <div class="slds-modal__content slds-p-around_medium">
            <lightning-button-group>
              <lightning-button label="Deactivate" disabled={isSaveBtnDisabled} variant="brand-outline" class="slds-m-left_x-small" onclick={deactivateUser}></lightning-button>
              <lightning-button label="Cancel" variant="brand-outline" class="slds-m-left_x-small" onclick={closeDeactivateUserModal}></lightning-button>
          </lightning-button-group>
          </div>
        </div>
      </section>
      <div class="slds-backdrop slds-backdrop_open"></div>
    </template>

    <!--User Edit Modal-->
    <template if:true={showContactEditModal}>
      <section role="dialog"
              tabindex="-1"
              aria-labelledby="modal-heading-01"
              aria-modal="true"
              aria-describedby="modal-content-id-1"
              class="slds-modal slds-fade-in-open slds-modal-medium">
        <div class="slds-modal__container">
          <header class="slds-modal__header">
            <button class="slds-button slds-button_icon slds-modal__close slds-button_icon-inverse" title="Close" onclick={closeUserEditModal}>
              <lightning-icon icon-name="utility:close" size="medium">
              </lightning-icon>
              <span class="slds-assistive-text">Close</span>
            </button>
            <h2 class="slds-text-heading_medium slds-hyphenate">Edit Contact</h2>
          </header>
  
          <div class="slds-modal__content slds-p-around_medium">
            <lightning-record-edit-form
                object-api-name="Contact"
                record-id={contactId}
                onsubmit={handleContactUpdate}
                density="comfy">
              
              <lightning-messages></lightning-messages>
              <div class="slds-form__row">
                <div class="slds-form__item">
                  <lightning-input-field field-name="FirstName" required></lightning-input-field>
                </div>
                <div class="slds-form__item">
                  <lightning-input-field field-name="LastName" required></lightning-input-field>
                </div> 
              </div>
              <div class="slds-form__row">
                <div class="slds-form__item">
                  <lightning-input-field field-name="Email" required></lightning-input-field>
                </div>
                <div class="slds-form__item">
                  <lightning-input-field field-name="MobilePhone"></lightning-input-field>
                </div>
              </div>
              <div class="slds-form__row">
                <div class="slds-form__item">
                  <lightning-input-field field-name="Phone"></lightning-input-field>
                </div> 
                <div class="slds-form__item">
                  <lightning-input-field field-name="HomePhone"></lightning-input-field>
                </div>
              </div>   
              <div class="slds-form__row">
                <div class="slds-form__item">
                  <lightning-input-field field-name="OtherPhone"></lightning-input-field>
                </div> 
                <div class="slds-form__item">
                  <lightning-input-field field-name="Title"></lightning-input-field>
                </div> 
              </div>                         
              <div class="slds-form__row">
                <div class="slds-form__item">
                  <lightning-input-field field-name="MailingAddress"></lightning-input-field>
                </div>
              </div> 
              <div class="slds-form__row">
                <div class="slds-form__item">
                  <lightning-input-field field-name="Description"></lightning-input-field>
                </div>
              </div>             
              <div style="display: none;">
                <div class="slds-form__row">
                  <div class="slds-form__item">
                    <lightning-input-field field-name="AccountId" value={accountId} readonly required></lightning-input-field>
                  </div>                
                </div>
              </div>
              <footer class="slds-modal__footer">
                <lightning-button label="Cancel" variant="neutral" onclick={closeUserEditModal}></lightning-button>&nbsp;&nbsp;&nbsp;&nbsp;
                <lightning-button label={saveButtonLabel} disabled={isSaveBtnDisabled} variant="brand" type="submit"></lightning-button>
            </footer>               
            </lightning-record-edit-form>
            </div>             
          </div>
        </section>
        <div class="slds-backdrop slds-backdrop_open"></div>
        
      </template>      

</template>